searchNodes=[{"doc":"Terminus allows you to crawl and subscribe to Bitcoin transaction events and download binary data from transactions, using a combination of Bitbus and Bitsocket, and BitFS.Terminus provides a single unified interface for querying Planaria corp APIs in a highly performant manner. Each request is a GenStage process, enabling you to create powerful concurrent data flows. Terminus may well be the most powerful way of querying Bitcoin in the Universe!APIsTerminus can be used to interface with the following Planaria Corp APIs.Bitbus - crawl filtered subsets of confirmed Bitcoin transactions in blocks.Bitsocket - subscribe to a live, filterable stream of realtime transaction events.BitFS - fetch raw binary data chunks (over 512kb) indexed from all Bitcoin transactions.AuthenticationBoth Bitbus and Bitsocket require a token to authenticate requests. (The Bitsocket listen API currently doesn't require a token but that is likely to change). Currently tokens are free with no usage limits. (Also likely to change)Get your Planaria Token.Query languageBoth Bitbus and Bitsocket use the same MongoDB-like query language, known as Bitquery. Terminus fully supports both the TXO (Transaction Object) and BOB (Bitcoin OP_RETURN Bytecode) schemas, and allows the optional use of shorthand queries (just the q value).iex&gt; Terminus.Bitbus.fetch!(%{ ...&gt; find: %{ &quot;out.s2&quot; =&gt; &quot;1LtyME6b5AnMopQrBPLk4FGN8UBuhxKqrn&quot; }, ...&gt; sort: %{ &quot;blk.i&quot;: -1 }, ...&gt; project: %{ &quot;tx.h&quot;: 1 }, ...&gt; limit: 5 ...&gt; }, token: token) [ %{&quot;tx&quot; =&gt; %{&quot;h&quot; =&gt; &quot;fca7bdd7658613418c54872212811cf4c5b4f8ee16864eaf70cb1393fb0df6ca&quot;}}, %{&quot;tx&quot; =&gt; %{&quot;h&quot; =&gt; &quot;79ae3ca23d1067b9ab45aba7e8ff4de1943e383e9a33e562d5ffd8489f388c93&quot;}}, %{&quot;tx&quot; =&gt; %{&quot;h&quot; =&gt; &quot;5526989417f28da5e0c99b58863db58c1faf8862ac9325dc415ad4b11605c1b1&quot;}}, %{&quot;tx&quot; =&gt; %{&quot;h&quot; =&gt; &quot;0bac587681360f961dbccba4c49a5c8f1b6f0bef61fe8501a28dcfe981a920b5&quot;}}, %{&quot;tx&quot; =&gt; %{&quot;h&quot; =&gt; &quot;fa13a8f0f5688f761b2f34949bb35fa5d6fd14cb3d49c2c1617363b6984df162&quot;}} ]Using TerminusTerminus can be used as a simple API client, or a turbo-charged, concurrent multi-stream Bitcoin scraper on steroids. You decide.The following modules are the primary ways of using Terminus.Terminus.Bitbus - functions for crawling and query confirmed Bitcoin transactions.Terminus.Bitsocket - query mempool transactions and listen to realtime transaction events.Terminus.BitFS - fetch binary data blobs embedded in Bitcoin transactions.Terminus.Omni - conveniently fetch confirmed and mempool transactions together.Terminus.Planaria - run Bitcoin scraper processes under your application's supervision tree.StreamsMost Terminus functions return a streaming Enumerable.t/0 allowing you to compose data processing pipelines and operations.iex&gt; Terminus.Bitbus.crawl!(query, token: token) ...&gt; |&gt; Stream.map(&amp;Terminus.BitFS.scan_tx/1) ...&gt; |&gt; Stream.each(&amp;save_to_db/1) ...&gt; |&gt; Stream.run :okOmniSometimes it's necessary to query both confirmed and confirmed transaction simultaneously. This is where Terminus.Omni comes in, effectively replicating the functionality of legacy Planaria APIs and returning returning results from Bitbus and Bitsocket in one call.iex&gt; Terminus.Omni.fetch(query, token: token) {:ok, %{ c: [...], # collection of confirmed tx u: [...] # collection of mempool tx }}You can also easily find a single transaction by its txid irrespective of whether it is confirmed or not.iex&gt; Terminus.Omni.find(txid, token: token) {:ok, %{ &quot;tx&quot; =&gt; %{&quot;h&quot; =&gt; &quot;fca7bdd7658613418c54872212811cf4c5b4f8ee16864eaf70cb1393fb0df6ca&quot;}, ... }}PlanariaUsing Terminus.Planaria inside a module allows you to simply recreate Planaria-like state machine functionality.Planarias can be started under your app's supervision tree, allowing multiple Planaria processes to run concurrently.defmodule TwetchScraper do @query %{ &quot;find&quot; =&gt; %{ &quot;out.s2&quot;: &quot;19HxigV4QyBv3tHpQVcUEQyq1pzZVdoAut&quot;, &quot;out.s25&quot;: &quot;twetch&quot; } } use Terminus.Planaria, token: Application.get_env(:my_app, :token), from: 600000, query: @query def handle_data(:block, txns) do # Handle confirmed transactions end def handle_data(:mempool, txns) do # Handle unconfirmed transactions end endConcurrencyUnder the hood, each Terminus request is a GenStage producer process, and the bare pid can be returned. This allows you to take full advantage of Elixir's concurrency, by either using with your own GenStage consumers or using a tool like Flow to create powerful concurrent pipelines.# One stream of transactions will be distributed across eight concurrent # processes for mapping and saving the data. iex&gt; {:ok, pid} = Terminus.Bitbus.crawl(query, token: token, stage: true) iex&gt; Flow.from_stages([pid], stages: 8) ...&gt; |&gt; Flow.map(&amp;Terminus.BitFS.scan_tx/1) ...&gt; |&gt; Flow.map(&amp;save_to_db/1) ...&gt; |&gt; Flow.run :ok","ref":"Terminus.html","title":"Terminus","type":"module"},{"doc":"BitFS URI scheme.","ref":"Terminus.html#t:bitfs_uri/0","title":"Terminus.bitfs_uri/0","type":"type"},{"doc":"Bitcoin data query language.","ref":"Terminus.html#t:bitquery/0","title":"Terminus.bitquery/0","type":"type"},{"doc":"On-data callback function.","ref":"Terminus.html#t:callback/0","title":"Terminus.callback/0","type":"type"},{"doc":"Hex-encoded transaction ID.","ref":"Terminus.html#t:txid/0","title":"Terminus.txid/0","type":"type"},{"doc":"Module for interfacing with the BitFS API.BitFS crawls the Bitcoin blockchain to find and store all the bitcoin script pushdata chunks larger than 512 bytes.BitFS is an autonomous file system constructed from Bitcoin transactions.BitFS URI schemeFiles are referenced using the BitFS URI scheme.# bitfs://&lt;TRANSACTION_ID&gt;.(in|out).&lt;SCRIPT_INDEX&gt;.&lt;CHUNK_INDEX&gt; &quot;bitfs://13513153d455cdb394ce01b5238f36e180ea33a9ccdf5a9ad83973f2d423684a.out.0.4&quot;Terminus accepts given BitFS URI strings with or without the bitfs:// prefix.UsageTo simply return the binary data for any BitFS URI use fetch/2.iex&gt; Terminus.BitFS.fetch(uri) {:ok, &lt;&lt;...&gt;&gt;}It is also possible to scan entire transactions and automatically fetch the binary data for any BitFS URIs discovered in the transaction. The binary data is added to the same output script at the same index with a d prefixed attribute.iex&gt; tx = %{ ...&gt; &quot;out&quot; =&gt; [%{ ...&gt; &quot;f4&quot; =&gt; &quot;13513153d455cdb394ce01b5238f36e180ea33a9ccdf5a9ad83973f2d423684a.out.0.4&quot;, ...&gt; ... ...&gt; }] ...&gt; } iex&gt; Terminus.BitFS.scan_tx(tx) %{ &quot;out&quot; =&gt; [%{ &quot;f4&quot; =&gt; &quot;13513153d455cdb394ce01b5238f36e180ea33a9ccdf5a9ad83973f2d423684a.out.0.4&quot;, &quot;d4&quot; =&gt; &lt;&lt;...&gt;&gt;, ... }] }","ref":"Terminus.BitFS.html","title":"Terminus.BitFS","type":"module"},{"doc":"Fetches the binary blob data from BitFS using the given BitFS URI.Returns the result in an :ok / :error tuple pair.By default the entire data response is returned, although optionally a streaming Enumerable.t/0 can be returned or a linked GenStage pid.OptionsThe accepted options are:stream - Return a streaming Enumerable.t/0. Defaults to false.stage - Return a linked GenStage pid. Defaults to false.ExamplesFiles are references using the BitFS URI scheme.# &lt;TRANSACTION_ID&gt;.(in|out).&lt;SCRIPT_INDEX&gt;.&lt;CHUNK_INDEX&gt; &quot;13513153d455cdb394ce01b5238f36e180ea33a9ccdf5a9ad83973f2d423684a.out.0.4&quot;By default Terminus.BitFS.fetch/2 returns the binary data of the file.iex&gt; Terminus.BitFS.fetch(uri) {:ok, &lt;&lt;...&gt;&gt;}Optionally a streaming Enumerable.t/0 can be returned.iex&gt; Terminus.BitFS.fetch(uri, stream: true) {:ok, %Stream{}}Or the pid of the GenStage producer can be returned. iex&gt; Terminus.BitFS.fetch(uri, stage: true) {:ok, #PID&lt;&gt;}","ref":"Terminus.BitFS.html#fetch/2","title":"Terminus.BitFS.fetch/2","type":"function"},{"doc":"As fetch/2 but returns the result or raises an exception if it fails.","ref":"Terminus.BitFS.html#fetch!/2","title":"Terminus.BitFS.fetch!/2","type":"function"},{"doc":"Scans the given transaction script map, fetches data for any BitFS URI references, and returns a modified map with the data added.Handles both txo and bob schema scripts.ExamplesWhere a BitFS reference is found in a txo script, the fetched data is added to the script at the same index as the reference. For example, if a BitFS reference is found at f4, a new attribute d4 is put into the script containing the data.iex&gt; output = %{ ...&gt; &quot;f4&quot; =&gt; &quot;13513153d455cdb394ce01b5238f36e180ea33a9ccdf5a9ad83973f2d423684a.out.0.4&quot;, ...&gt; ... ...&gt; } iex&gt; Terminus.BitFS.scan_script(output) %{ &quot;f4&quot; =&gt; &quot;13513153d455cdb394ce01b5238f36e180ea33a9ccdf5a9ad83973f2d423684a.out.0.4&quot;, &quot;d4&quot; =&gt; &lt;&lt;...&gt;&gt;, # binary data added ... }With bob scripts, each cell is scanned and where a BitFS reference is found, a new d attribute is added to that cell containing the fetched data.iex&gt; output = %{&quot;tape&quot; =&gt; [ ...&gt; %{&quot;cell&quot; =&gt; %{ ...&gt; &quot;f&quot; =&gt; &quot;13513153d455cdb394ce01b5238f36e180ea33a9ccdf5a9ad83973f2d423684a.out.0.4&quot;, ...&gt; ... ...&gt; }}, ...&gt; ... ...&gt; ]} iex&gt; Terminus.BitFS.scan_script(output) %{&quot;tape&quot; =&gt; [ %{&quot;cell&quot; =&gt; %{ &quot;f&quot; =&gt; &quot;13513153d455cdb394ce01b5238f36e180ea33a9ccdf5a9ad83973f2d423684a.out.0.4&quot;, &quot;d&quot; =&gt; &lt;&lt;...&gt;&gt;, # binary data added ... }}, ... ]}","ref":"Terminus.BitFS.html#scan_script/1","title":"Terminus.BitFS.scan_script/1","type":"function"},{"doc":"Scans the given transaction map, fetches data for any BitFS URI references, and returns a modified map with the data added.The function handles both txo and bob schema transactions. See the examples for scan_script/1.","ref":"Terminus.BitFS.html#scan_tx/1","title":"Terminus.BitFS.scan_tx/1","type":"function"},{"doc":"Module for interfacing with the Bitbus API.Bitbus is a powerful API that allows you to crawl a filtered subset of the Bitcoin blockchain. Bitbus indexes blocks, thus can be used to crawl confirmed transactions.We run a highly efficient bitcoin crawler which indexes the bitcoin blockchain. Then we expose the index as an API so anyone can easily crawl ONLY the subset of bitcoin by crawling bitbus.SchemaBitbus transaction documents have the following schema:%{ &quot;_id&quot; =&gt; &quot;...&quot;, # Bitbus document ID &quot;blk&quot; =&gt; %{ &quot;h&quot; =&gt; &quot;...&quot;, # Block hash &quot;i&quot; =&gt; int, # Block height &quot;t&quot; =&gt; int, # Block timestamp }, &quot;in&quot; =&gt; [...], # List of inputs &quot;lock&quot; =&gt; int, # Lock time &quot;out&quot; =&gt; [...], # List of outputs &quot;tx&quot; =&gt; %{ &quot;h&quot; =&gt; &quot;...&quot; # Transaction hash } }Terminus supports both of the Bitbus public enpoints. The endpoint can be selected by passing the :host option to any API method.The available endpoints are::txo - Query and return transactions in the Transaction Object schema. Default.:bob - Query and return transactions in the Bitcoin OP_RETURN Bytecode schema.iex&gt; Terminus.Bitbus.fetch(query, token: token, host: :bob)UsageFor smaller queries of limited results, fetch/2 can be used to return a list of transactions:iex&gt; Terminus.Bitbus.fetch(%{ ...&gt; find: %{ &quot;out.s2&quot; =&gt; &quot;1LtyME6b5AnMopQrBPLk4FGN8UBuhxKqrn&quot; }, ...&gt; sort: %{ &quot;blk.i&quot;: -1 }, ...&gt; limit: 5 ...&gt; }, token: token) {:ok, [ %{ &quot;tx&quot; =&gt; %{&quot;h&quot; =&gt; &quot;fca7bdd7658613418c54872212811cf4c5b4f8ee16864eaf70cb1393fb0df6ca&quot;}, ... }, ... ]}For larger crawl operations, use crawl/3 to stream results into your own data processing pipeline.iex&gt; Terminus.Bitbus.crawl!(query, token: token) ...&gt; |&gt; Stream.map(&amp;Terminus.BitFS.scan_tx/1) ...&gt; |&gt; Stream.each(&amp;save_to_db/1) ...&gt; |&gt; Stream.run :ok","ref":"Terminus.Bitbus.html","title":"Terminus.Bitbus","type":"module"},{"doc":"Crawls Bitbus for transactions using the given query and returns a stream.Returns the result in an :ok / :error tuple pair.All requests must provide a valid Planaria token. By default a streaming Enumerable.t/0 is returned. Optionally a linked GenStage pid can be returned for using in combination with your own GenStage consumer.If a callback is provided, the stream is automatically run and the callback is called on each transaction.OptionsThe accepted options are:token - Planaria authentication token. Required.host - The Bitbus host. Defaults to &quot;https://txo.bitbus.network&quot;.stage - Return a linked GenStage pid. Defaults to false.ExamplesQueries should be in the form of any valid Bitquery.query = %{ find: %{ &quot;out.s2&quot; =&gt; &quot;1LtyME6b5AnMopQrBPLk4FGN8UBuhxKqrn&quot; } }By default Terminus.Bitbus.crawl/3 returns a streaming Enumerable.t/0.iex&gt; Terminus.Bitbus.crawl(query, token: token) {:ok, %Stream{}}Optionally the pid of the GenStage producer can be returned.iex&gt; Terminus.Bitbus.crawl(query, token: token, stage: true) {:ok, #PID&lt;&gt;}If a callback is provided, the function returns :ok and the callback is called on each transaction.iex&gt; Terminus.Bitbus.crawl(query, [token: token], fn tx -&gt; ...&gt; IO.inspect tx ...&gt; end) :ok","ref":"Terminus.Bitbus.html#crawl/3","title":"Terminus.Bitbus.crawl/3","type":"function"},{"doc":"As crawl/3 but returns the result or raises an exception if it fails.","ref":"Terminus.Bitbus.html#crawl!/3","title":"Terminus.Bitbus.crawl!/3","type":"function"},{"doc":"Crawls Bitbus for transactions using the given query and returns a list of transactions.Returns the result in an :ok / :error tuple pair.This function is suitable for smaller limited queries as the entire result set is loaded in to memory an returned. For large crawls, crawl/3 is preferred as the results can be streamed and processed more efficiently.OptionsThe accepted options are:token - Planaria authentication token. Required.host - The Bitbus host. Defaults to &quot;https://txo.bitbus.network&quot;.Examples iex&gt; Terminus.Bitbus.fetch(query, token: token) {:ok, [ %{ &quot;tx&quot; =&gt; %{&quot;h&quot; =&gt; &quot;bbae7aa467cb34010c52033691f6688e00d9781b2d24620cab51827cd517afb8&quot;}, ... }, ... ]}","ref":"Terminus.Bitbus.html#fetch/2","title":"Terminus.Bitbus.fetch/2","type":"function"},{"doc":"As fetch/2 but returns the result or raises an exception if it fails.","ref":"Terminus.Bitbus.html#fetch!/2","title":"Terminus.Bitbus.fetch!/2","type":"function"},{"doc":"Fetches and returns the current status of Bitbus.Returns the result in an :ok / :error tuple pair. The returned map of data includes the current block header as well as the total number of transactions in the block (count).Examplesiex&gt; Terminus.Bitbus.status {:ok, %{ &quot;hash&quot; =&gt; &quot;00000000000000000249f9bd0e127ebc62125a72686a7470fe4a41e4add2deb1&quot;, &quot;prevHash&quot; =&gt; &quot;000000000000000001b3ea9c4c073226c6233583ab510ea10ce01faff17c89f3&quot;, &quot;merkleRoot&quot; =&gt; &quot;fb19b1ff5cd838cfca399f9f2e46fa3a0e9f0da0459f91bfd6d02a75756f3a4d&quot;, &quot;time&quot; =&gt; 1586457301, &quot;bits&quot; =&gt; 402821143, &quot;nonce&quot; =&gt; 1471454449, &quot;height&quot; =&gt; 629967, &quot;count&quot; =&gt; 2193 }}","ref":"Terminus.Bitbus.html#status/1","title":"Terminus.Bitbus.status/1","type":"function"},{"doc":"As status/1 but returns the result or raises an exception if it fails.","ref":"Terminus.Bitbus.html#status!/1","title":"Terminus.Bitbus.status!/1","type":"function"},{"doc":"Module for interfacing with the Bitsocket API.Bitsocket sends you realtime events from the Bitcoin blockchain. It uses Server Sent Events to stream new unconfirmed transactions as soon as they appear on the Bitcoin network.Bitsocket is like Websocket, but for Bitcoin. With just a single Bitsocket connection, you get access to a live, filterable stream of all transaction events across the entire bitcoin peer network.SchemaRealtime transactions have a similar schema to Bitbus documents. However, as these are unconfirmed transactions, they have no blk infomation and provide a timestamp attribute reflecting when Bitsocket first saw the transaction.%{ &quot;_id&quot; =&gt; &quot;...&quot;, # Bitbus document ID &quot;in&quot; =&gt; [...], # List of inputs &quot;lock&quot; =&gt; int, # Lock time &quot;out&quot; =&gt; [...], # List of outputs &quot;timestamp&quot; =&gt; int, # Timestamp of when tx seen &quot;tx&quot; =&gt; %{ &quot;h&quot; =&gt; &quot;...&quot; # Transaction hash } }Terminus supports both of the Bitsocket public enpoints. The endpoint can be selected by passing the :host option to any API method.The available endpoints are::txo - Query and return transactions in the Transaction Object schema. Default.:bob - Query and return transactions in the Bitcoin OP_RETURN Bytecode schema.iex&gt; Terminus.Bitsocket.listen(query, host: :bob)UsageSubscribe to realtime Bitcoin transactions using listen/3 and stream the results into your own data processing pipeline.iex&gt; Terminus.Bitsocket.listen!(query) ...&gt; |&gt; Stream.map(&amp;Terminus.BitFS.scan_tx/1) ...&gt; |&gt; Stream.each(&amp;save_to_db/1) ...&gt; |&gt; Stream.run :okBitsocket also provides an API for querying and crawling the transaction event database which indexes all transactions in the previous 24 hours. Both crawl/3 and fetch/2 can be used to query these events.iex&gt; Terminus.Bitsocket.fetch(%{ ...&gt; find: %{ ...&gt; &quot;out.s2&quot; =&gt; &quot;1LtyME6b5AnMopQrBPLk4FGN8UBuhxKqrn&quot;, ...&gt; &quot;timestamp&quot; =&gt; %{&quot;$gt&quot;: :os.system_time(:millisecond) - 60000} ...&gt; }, ...&gt; sort: %{ &quot;timestamp&quot;: -1 } ...&gt; }, token: token) {:ok, [ %{ &quot;tx&quot; =&gt; %{&quot;h&quot; =&gt; &quot;fca7bdd7658613418c54872212811cf4c5b4f8ee16864eaf70cb1393fb0df6ca&quot;}, ... }, ... ]}","ref":"Terminus.Bitsocket.html","title":"Terminus.Bitsocket","type":"module"},{"doc":"Crawls the Bitsocket event database for transactions using the given query and returns a stream.Returns the result in an :ok / :error tuple pair.All requests must provide a valid Planaria token. By default a streaming Enumerable.t/0 is returned. Optionally a linked GenStage pid can be returned for using in combination with your own GenStage consumer.If a callback is provided, the stream is automatically run and the callback is called on each transaction.OptionsThe accepted options are:token - Planaria authentication token. Required.host - The Bitsocket host. Defaults to txo.bitsocket.network.stage - Return a linked GenStage pid. Defaults to false.ExamplesQueries should be in the form of any valid Bitquery.query = %{ find: %{ &quot;out.s2&quot; =&gt; &quot;1LtyME6b5AnMopQrBPLk4FGN8UBuhxKqrn&quot; } }By default Terminus.Bitsocket.crawl/2 returns a streaming Enumerable.t/0.iex&gt; Terminus.Bitsocket.crawl(query, token: token) {:ok, %Stream{}}Optionally the pid of the GenStage producer can be returned.iex&gt; Terminus.Bitsocket.crawl(query, token: token, stage: true) {:ok, #PID&lt;&gt;}If a callback is provided, the function returns :ok and the callback is called on each transaction.iex&gt; Terminus.Bitsocket.crawl(query, [token: token], fn tx -&gt; ...&gt; IO.inspect tx ...&gt; end) :ok","ref":"Terminus.Bitsocket.html#crawl/3","title":"Terminus.Bitsocket.crawl/3","type":"function"},{"doc":"As crawl/3 but returns the result or raises an exception if it fails.","ref":"Terminus.Bitsocket.html#crawl!/3","title":"Terminus.Bitsocket.crawl!/3","type":"function"},{"doc":"Crawls the Bitsocket event database for transactions using the given query and returns a stream.Returns the result in an :ok / :error tuple pair.This function is suitable for smaller limited queries as the entire result set is loaded in to memory an returned. For large crawls, crawl/3 is preferred as the results can be streamed and processed more efficiently.OptionsThe accepted options are:token - Planaria authentication token. Required.host - The Bitsocket host. Defaults to txo.bitsocket.network.Examples iex&gt; Terminus.Bitsocket.fetch(query, token: token) [ %{ &quot;tx&quot; =&gt; %{&quot;h&quot; =&gt; &quot;bbae7aa467cb34010c52033691f6688e00d9781b2d24620cab51827cd517afb8&quot;}, ... }, ... ]","ref":"Terminus.Bitsocket.html#fetch/2","title":"Terminus.Bitsocket.fetch/2","type":"function"},{"doc":"As fetch/2 but returns the result or raises an exception if it fails.","ref":"Terminus.Bitsocket.html#fetch!/2","title":"Terminus.Bitsocket.fetch!/2","type":"function"},{"doc":"Subscribes to Bitsocket and streams realtime transaction events using the given query.Returns the result in an :ok / :error tuple pair.By default a streaming Enumerable.t/0 is returned. Optionally a linked GenStage pid can be returned for using in combination with your own GenStage consumer.If a callback is provided, the stream is automatically run and the callback is called on each transaction.As Bitsocket streams transactions using Server Sent Events, the stream will stay open (and blocking) permanently. This is best managed inside a long-running Elixir process.OptionsThe accepted options are:host - The Bitsocket host. Defaults to txo.bitsocket.network.stage - Return a linked GenStage pid instead of a stream.recycle - Number of seconds after which to recycle to a quiet Bitsocket request. Defaults to 900.ExamplesQueries should be in the form of any valid Bitquery.query = %{ find: %{ &quot;out.s2&quot; =&gt; &quot;1LtyME6b5AnMopQrBPLk4FGN8UBuhxKqrn&quot; } }By default Terminus.Bitsocket.listen/2 returns a streaming Enumerable.t/0.iex&gt; Terminus.Bitsocket.listen(query, token: token) {:ok, %Stream{}}Optionally the pid of the GenStage producer can be returned.iex&gt; Terminus.Bitsocket.listen(query, token: token, stage: true) {:ok, #PID&lt;&gt;}If a callback is provided, the stream returns :ok and the callback is called on each transaction.iex&gt; Terminus.Bitsocket.listen(query, [token: token], fn tx -&gt; ...&gt; IO.inspect tx ...&gt; end) :ok","ref":"Terminus.Bitsocket.html#listen/3","title":"Terminus.Bitsocket.listen/3","type":"function"},{"doc":"As listen/3 but returns the result or raises an exception if it fails.","ref":"Terminus.Bitsocket.html#listen!/2","title":"Terminus.Bitsocket.listen!/2","type":"function"},{"doc":"Module for conveniently fetching data from both Bitbus and Bitsocket concurrently.Terminus.Omni replicates the functionality of legacy Planaria APIs by allowing you to query for both confirmed and unconfirmed transactions in one call. HTTP requests to both APIs occur concurrently and a combined result is returned when both APIs have yielded a response.Mempool transactions are intelligently handled. The Bitsocket event database is queried to safely gather enough transactions to cover the time period since the last block, and then cross-referenced with confirmed transactions to ensure there are no duplicates. It just... works!ExamplesUse fetch/2 to query for a combined set of confirmed and unconfimred transactions.iex&gt; Terminus.Omni.fetch(%{ ...&gt; find: %{ &quot;out.s2&quot; =&gt; &quot;1LtyME6b5AnMopQrBPLk4FGN8UBuhxKqrn&quot; }, ...&gt; limit: 5 ...&gt; }, token: token) {:ok, %{ c: [...], # 5 confirmed tx u: [...], # 5 unconfirmed tx }}Alterntivly, find/2 allows for a single transaction to be easily found by it's txid, irrespective of whether the transaction is confirmed or in the mempool.iex&gt; Terminus.Omni.find(txid, token: token) {:ok, %{ &quot;tx&quot; =&gt; %{&quot;h&quot; =&gt; &quot;fca7bdd7658613418c54872212811cf4c5b4f8ee16864eaf70cb1393fb0df6ca&quot;}, ... }}","ref":"Terminus.Omni.html","title":"Terminus.Omni","type":"module"},{"doc":"Crawls Bitbus and Bitsocket for transactions using the given query and returns a map containing both confirmed and mempool transactions.Returns the result in an :ok / :error tuple pair.If no limit is specified in the given bitquery map, a default limit of 20 is added to the query. This limit is applied to both sets of results, meaning a maximum of 40 unique transactions may be returned.OptionsThe accepted options are:token - Planaria authentication token. Required.host - The Bitbus host. Defaults to :txo.ExamplesGet the 5 latest confirmed and unconfirmed WeatherSV transactions.iex&gt; Terminus.Omni.fetch(%{ ...&gt; find: %{ &quot;out.s2&quot; =&gt; &quot;1LtyME6b5AnMopQrBPLk4FGN8UBuhxKqrn&quot; }, ...&gt; limit: 5 ...&gt; }, token: token) {:ok, %{ c: [...], # 5 confirmed tx u: [...], # 5 unconfirmed tx }}","ref":"Terminus.Omni.html#fetch/2","title":"Terminus.Omni.fetch/2","type":"function"},{"doc":"As fetch/2 but returns the result or raises an exception if it fails.","ref":"Terminus.Omni.html#fetch!/2","title":"Terminus.Omni.fetch!/2","type":"function"},{"doc":"Query Bitbus and Bitsocket for a single transaction by the given txid.Returns the result in an :ok / :error tuple pair.OptionsThe accepted options are:token - Planaria authentication token. Required.host - The Bitbus host. Defaults to :txo.Examplesiex&gt; Terminus.Omni.find(txid, token: token) {:ok, %{ &quot;tx&quot; =&gt; %{&quot;h&quot; =&gt; &quot;fca7bdd7658613418c54872212811cf4c5b4f8ee16864eaf70cb1393fb0df6ca&quot;}, ... }}","ref":"Terminus.Omni.html#find/2","title":"Terminus.Omni.find/2","type":"function"},{"doc":"As find/2 but returns the result or raises an exception if it fails.","ref":"Terminus.Omni.html#find!/2","title":"Terminus.Omni.find!/2","type":"function"},{"doc":"A behaviour module for implementing Planaria-like state machines in Elixir.A module using Terminus.Planaria is a GenStage consumer process that will automatically mangage its own producer processes to crawl and listen to Bitcoin transaction events. Developers only need to implement callback functions to handle transaction events.ExampleThe following code demonstrates how a Twetch scraper can be built in a few lines of code.defmodule TwetchScraper do @query %{ &quot;find&quot; =&gt; %{ &quot;out.s2&quot;: &quot;19HxigV4QyBv3tHpQVcUEQyq1pzZVdoAut&quot;, &quot;out.s25&quot;: &quot;twetch&quot; } } use Terminus.Planaria, token: Application.get_env(:my_app, :token), from: 600000, query: @query def handle_data(:block, txns) do # Handle confirmed transactions end def handle_data(:mempool, txns) do # Handle unconfirmed transactions end endThe handle_data/2 callback can be implemented for each tx_event, and is typically be used to persist required data from each transaction. The handle_tape/2 callback can also be implemented for loading and persisting the tape head so a re-crawl isn't necessary if the process is interrupted.OptionsWhen invoking use Terminus.Planaria, the following config options are accepted::token - Planaria Token. Required.:host - The Bitbus/Bitsocket endpoint to use. Defaults to :txo.:from - The block height from which to crawl for transactions. Required.:query - Full or shorthand Bitquery map.:poll - Interval (in seconds) to poll Bitbus for new blocks. Defaults to 300 (5 minutes).:recycle - Interval (in seconds) to recycle quiet Bitsocket requests. Defaults to 900 (15 minutes).SupervisionEach Terminus.Planaria will most commonly be started under your application's supervision tree. When you invoke use Terminus.Planaria, it automatically defines a child_spec/1 function so your Planaria modules can be started directly under a supervisor.And this is where we can have some fun and take full advantage of Elixir's concurrency model. Why not run many Planarias concurrently in your app?children = [ TwetchScraper, PreevScraper, WeathersvScraper ] Supervisor.start_link(children, strategy: :one_for_all)","ref":"Terminus.Planaria.html","title":"Terminus.Planaria","type":"behaviour"},{"doc":"Invoked for each new transaction seen by the Planaria.This is the main callback you will need to implement for your Planaria module. Typically it will be used to pull the necessary data from each transaction event and store it to a local database.When an unconfirmed transaction is seen the callback is invoked with the tx_event of :mempool. For each confirmed transaction, the callback is invoked with the tx_event of :block. The callback can return any value.Examplesdef handle_data(:block, txns) do txns |&gt; Enum.map(&amp;MyApp.Transaction.build/1) |&gt; Repo.insert(on_conflict: :replace_all, conflict_target: :txid) end def handle_data(:mempool, txns) do txns |&gt; Enum.map(&amp;MyApp.Transaction.build/1) |&gt; Repo.insert end","ref":"Terminus.Planaria.html#c:handle_data/2","title":"Terminus.Planaria.handle_data/2","type":"callback"},{"doc":"Invoked when a Planaria starts and also after each crawl of new blocks.This callback can be used to load and persist the tape head so a re-crawl isn't necessary if the process is interrupted.When a Planaria starts the callback is invoked with the tape_event of :start. This provides an oppurtunity to load the current :head of the tape from a database and update the given tape. The callback must return {:ok, tape}.After each crawl of block data the callback in invoked with the tape_event if :block. This allows us to store the tape :head. In this case any return value is acceptable.ExamplesLoad the :head from a database when the Planaria starts.def handle_tape(:start, tape) do tape = case MyApp.Config.get(&quot;tape_head&quot;) do {:ok, head} -&gt; put_in(tape.head, head) _ -&gt; tape end {:ok, tape} endPersist the :head after each crawl of new blocks.def handle_tape(:block, tape) do MyApp.Config.put(&quot;tape_head&quot;, tape.head) end","ref":"Terminus.Planaria.html#c:handle_tape/2","title":"Terminus.Planaria.handle_tape/2","type":"callback"},{"doc":"Starts a Terminus.Planaria process without links (outside of a supervision tree).See start_link/3 for more information.","ref":"Terminus.Planaria.html#start/3","title":"Terminus.Planaria.start/3","type":"function"},{"doc":"Starts a Terminus.Planaria process linked to the current process.This is often used to start the Planaria as part of a supervision tree.","ref":"Terminus.Planaria.html#start_link/3","title":"Terminus.Planaria.start_link/3","type":"function"},{"doc":"Planaria config.","ref":"Terminus.Planaria.html#t:config/0","title":"Terminus.Planaria.config/0","type":"type"},{"doc":"Planaria state.","ref":"Terminus.Planaria.html#t:t/0","title":"Terminus.Planaria.t/0","type":"type"},{"doc":"Planaria tape.","ref":"Terminus.Planaria.html#t:tape/0","title":"Terminus.Planaria.tape/0","type":"type"},{"doc":"Planaria tape event.","ref":"Terminus.Planaria.html#t:tape_event/0","title":"Terminus.Planaria.tape_event/0","type":"type"},{"doc":"Planaria transaction event.","ref":"Terminus.Planaria.html#t:tx_event/0","title":"Terminus.Planaria.tx_event/0","type":"type"},{"doc":"A GenStage producer module for creating streaming HTTP requests. Each request is a GenStage process, enabling creating powerful concurrent data flows.Usage# Create the connection process iex&gt; Terminus.HTTP.Client.connect(&quot;http://x.bitfs.network&quot;) {:ok, pid} # Begin a request iex&gt; Terminus.HTTP.Client.request(pid, &quot;GET&quot;, path) :ok # Stream the result iex&gt; GenStage.stream([{pid, cancel: :transient}]) %Stream{}","ref":"Terminus.HTTP.Client.html","title":"Terminus.HTTP.Client","type":"module"},{"doc":"Manually stops the Client process, closing it's HTTP request.","ref":"Terminus.HTTP.Client.html#close/2","title":"Terminus.HTTP.Client.close/2","type":"function"},{"doc":"Creates a new connection to a given server and returns a GenStage pid.OptionsThe accepted options are::decoder - Request body binary.:recycle_after - Number of seconds after which the request should be recycled if it has recieved no events (used in EventSource connections).","ref":"Terminus.HTTP.Client.html#connect/2","title":"Terminus.HTTP.Client.connect/2","type":"function"},{"doc":"Manually stops and restarts the client's current request.Alternatively, this can be automated by using the :recycle_after option when calling connect/2.","ref":"Terminus.HTTP.Client.html#recycle/1","title":"Terminus.HTTP.Client.recycle/1","type":"function"},{"doc":"Sends a request to the connected server.The function is asynchronous and returns :ok. The GenStage pid can be subscribed to to listen to streaming data chunks.OptionsThe accepted options are::headers - List of HTTP headers in tuple form.:body - Request body binary.:token - If provided, sets the Token HTTP header.:last_event_id - Used with EventSource connections. If provided, sets the Last-Event-ID header.","ref":"Terminus.HTTP.Client.html#request/4","title":"Terminus.HTTP.Client.request/4","type":"function"},{"doc":"Starts the client process without links (outside of a supervision tree).","ref":"Terminus.HTTP.Client.html#start/2","title":"Terminus.HTTP.Client.start/2","type":"function"},{"doc":"Starts a client process linked to the current process.This is often used to start the client process as part of a supervision tree.","ref":"Terminus.HTTP.Client.html#start_link/2","title":"Terminus.HTTP.Client.start_link/2","type":"function"},{"doc":"HTTP request status.0 - Connecting1 - Connected2 - Closed","ref":"Terminus.HTTP.Client.html#t:status/0","title":"Terminus.HTTP.Client.status/0","type":"type"},{"doc":"Terminus HTTP State.","ref":"Terminus.HTTP.Client.html#t:t/0","title":"Terminus.HTTP.Client.t/0","type":"type"},{"doc":"TODO","ref":"Terminus.HTTP.Response.html","title":"Terminus.HTTP.Response","type":"module"},{"doc":"Decodes the data in the given response data buffer, using the specified decoder.","ref":"Terminus.HTTP.Response.html#decode_data/2","title":"Terminus.HTTP.Response.decode_data/2","type":"function"},{"doc":"","ref":"Terminus.HTTP.Response.html#t:t/0","title":"Terminus.HTTP.Response.t/0","type":"type"},{"doc":"A mixin module providing functions for creating streaming HTTP requests.Examplesdefmodule BitFS do use Terminus.HTTPStream, hosts: [&quot;x.bitfs.network&quot;] def load_file(path) do case request(:fetch, &quot;GET&quot;, path, nil) do {:ok, data} -&gt; data {:error, reason} -&gt; raise reason end end def stream_file(path) do case request(:stream, &quot;GET&quot;, path, nil) do {:ok, stream} -&gt; stream {:error, reason} -&gt; raise reason end end end","ref":"Terminus.HTTPStream.html","title":"Terminus.HTTPStream","type":"module"},{"doc":"Opens a HTTP connection and begins a request, returning the binary/0 body of the response.Returns the result in an :ok / :error tuple pair.","ref":"Terminus.HTTPStream.html#fetch/4","title":"Terminus.HTTPStream.fetch/4","type":"function"},{"doc":"Runs the given streaming Enumerable.t/0 and executes the callback on each element of the stream.If the given callback is nil then the stream is passed through and returned.","ref":"Terminus.HTTPStream.html#handle_callback/2","title":"Terminus.HTTPStream.handle_callback/2","type":"function"},{"doc":"Normalizes the given Bitquery, automatically expanding shorthand queries.Examplesiex&gt; normalize_query(%{find: %{&quot;tx.h&quot; =&gt; &quot;abc&quot;}}) %{ v: 3, q: %{ find: %{ &quot;tx.h&quot; =&gt; &quot;abc&quot; } } }","ref":"Terminus.HTTPStream.html#normalize_query/1","title":"Terminus.HTTPStream.normalize_query/1","type":"function"},{"doc":"Opens a HTTP connection and begins a request, returning the GenStage pid of the request.Returns the result in an :ok / :error tuple pair.","ref":"Terminus.HTTPStream.html#request/4","title":"Terminus.HTTPStream.request/4","type":"function"},{"doc":"Opens a HTTP connection and begins a request, returning a streaming Enumerable.t/0.Returns the result in an :ok / :error tuple pair.","ref":"Terminus.HTTPStream.html#stream/4","title":"Terminus.HTTPStream.stream/4","type":"function"}]